diff --git a/src/test/modules/test_checksums/t/001_basic.pl b/src/test/modules/test_checksums/t/001_basic.pl
new file mode 100644
index 00000000000..728a5c4510c
--- /dev/null
+++ b/src/test/modules/test_checksums/t/001_basic.pl
@@ -0,0 +1,63 @@
+
+# Copyright (c) 2025, PostgreSQL Global Development Group
+
+# Test suite for testing enabling data checksums in an online cluster
+use strict;
+use warnings FATAL => 'all';
+
+use PostgreSQL::Test::Cluster;
+use PostgreSQL::Test::Utils;
+use Test::More;
+
+use FindBin;
+use lib $FindBin::RealBin;
+
+use DataChecksums::Utils;
+
+# Initialize node with checksums disabled.
+my $node = PostgreSQL::Test::Cluster->new('main');
+$node->init(no_data_checksums => 1);
+$node->start;
+
+# Create some content to have un-checksummed data in the cluster
+$node->safe_psql('postgres',
+	"CREATE TABLE t AS SELECT generate_series(1,10000) AS a;");
+
+# Ensure that checksums are turned off
+test_checksum_state($node, 'off');
+
+# Enable data checksums and wait for the state transition to 'on'
+enable_data_checksums($node, wait => 'on');
+
+# Run a dummy query just to make sure we can read back data
+my $result =
+  $node->safe_psql('postgres', "SELECT count(*) FROM t WHERE a > 1 ");
+is($result, '9999', 'ensure checksummed pages can be read back');
+
+# Enable data checksums again which should be a no-op so we explicitly don't
+# wait for any state transition as none should happen here
+enable_data_checksums($node);
+test_checksum_state($node, 'on');
+# ..and make sure we can still read/write data
+$node->safe_psql('postgres', "UPDATE t SET a = a + 1;");
+$result = $node->safe_psql('postgres', "SELECT count(*) FROM t WHERE a > 1");
+is($result, '10000', 'ensure checksummed pages can be read back');
+
+# Disable checksums again and wait for the state transition
+disable_data_checksums($node, wait => 'on');
+
+# Test reading data again
+$result = $node->safe_psql('postgres', "SELECT count(*) FROM t WHERE a > 1");
+is($result, '10000', 'ensure previously checksummed pages can be read back');
+
+# Re-enable checksums and make sure that the underlying data has changed to
+# ensure that checksums will be different.
+$node->safe_psql('postgres', "UPDATE t SET a = a + 1;");
+enable_data_checksums($node, wait => 'on');
+
+# Run a dummy query just to make sure we can read back the data
+$result = $node->safe_psql('postgres', "SELECT count(*) FROM t WHERE a > 1");
+is($result, '10000', 'ensure checksummed pages can be read back');
+
+$node->stop;
+done_testing();
diff --git a/src/test/modules/test_checksums/t/002_restarts.pl b/src/test/modules/test_checksums/t/002_restarts.pl
new file mode 100644
index 00000000000..6c17f304eac
--- /dev/null
+++ b/src/test/modules/test_checksums/t/002_restarts.pl
@@ -0,0 +1,110 @@
+
+# Copyright (c) 2024, PostgreSQL Global Development Group
+
+# Test suite for testing enabling data checksums in an online cluster with a
+# restart which breaks processing.
+use strict;
+use warnings FATAL => 'all';
+
+use PostgreSQL::Test::Cluster;
+use PostgreSQL::Test::Utils;
+use Test::More;
+
+use FindBin;
+use lib $FindBin::RealBin;
+
+use DataChecksums::Utils;
+
+# Initialize node with checksums disabled.
+my $node = PostgreSQL::Test::Cluster->new('main');
+$node->init(no_data_checksums => 1);
+$node->start;
+
+# Initialize result storage for queries
+my $result;
+
+# Create some content to have un-checksummed data in the cluster
+$node->safe_psql('postgres',
+	"CREATE TABLE t AS SELECT generate_series(1,10000) AS a;");
+
+# Ensure that checksums are disabled
+test_checksum_state($node, 'off');
+
+SKIP:
+{
+	skip 'Data checksum delay tests not enabled in PG_TEST_EXTRA', 6
+	  if (!$ENV{PG_TEST_EXTRA}
+		|| $ENV{PG_TEST_EXTRA} !~ /\bchecksum_extended\b/);
+
+	# Create a barrier for checksumming to block on, in this case a pre-
+	# existing temporary table which is kept open while processing is started.
+	# We can accomplish this by setting up an interactive psql process which
+	# keeps the temporary table created as we enable checksums in another psql
+	# process.
+	#
+	# This is a similar test to the synthetic variant in 005_injection.pl
+	# which fakes this scenario.
+	my $bsession = $node->background_psql('postgres');
+	$bsession->query_safe('CREATE TEMPORARY TABLE tt (a integer);');
+
+	# In another session, make sure we can see the blocking temp table but
+	# start processing anyways and check that we are blocked with a proper
+	# wait event.
+	$result = $node->safe_psql('postgres',
+		"SELECT relpersistence FROM pg_catalog.pg_class WHERE relname = 'tt';"
+	);
+	is($result, 't', 'ensure we can see the temporary table');
+
+	# Enabling data checksums shouldn't work as the process is blocked on the
+	# temporary table held open by $bsession. Ensure that we reach inprogress-
+	# on before we do more tests.
+	enable_data_checksums($node, wait => 'inprogress-on');
+
+	# Wait for processing to finish and the worker waiting for leftover temp
+	# relations to be able to actually finish
+	$result = $node->poll_query_until(
+		'postgres',
+		"SELECT wait_event FROM pg_catalog.pg_stat_activity "
+		  . "WHERE backend_type = 'datachecksum worker';",
+		'ChecksumEnableTemptableWait');
+
+	# The datachecksumsworker waits for temporary tables to disappear for 3
+	# seconds before retrying, so sleep for 4 seconds to be guaranteed to see
+	# a retry cycle
+	sleep(4);
+
+	# Re-check the wait event to ensure we are blocked on the right thing.
+	$result = $node->safe_psql('postgres',
+			"SELECT wait_event FROM pg_catalog.pg_stat_activity "
+		  . "WHERE backend_type = 'datachecksum worker';");
+	is($result, 'ChecksumEnableTemptableWait',
+		'ensure the correct wait condition is set');
+	test_checksum_state($node, 'inprogress-on');
+
+	# Stop the cluster while bsession is still attached.  We can't close the
+	# session first since the brief period between closing and stopping might
+	# be enough for checksums to get enabled.
+	$node->stop;
+	$bsession->quit;
+	$node->start;
+
+	# Ensure the checksums aren't enabled across the restart.  This leaves the
+	# cluster in the same state as before we entered the SKIP block.
+	test_checksum_state($node, 'off');
+}
+
+enable_data_checksums($node, wait => 'on');
+
+$result = $node->safe_psql('postgres', "SELECT count(*) FROM t WHERE a > 1");
+is($result, '9999', 'ensure checksummed pages can be read back');
+
+$result = $node->poll_query_until(
+	'postgres',
+	"SELECT count(*) FROM pg_stat_activity WHERE backend_type LIKE 'datachecksumsworker%';",
+	'0');
+is($result, 1, 'await datachecksums worker/launcher termination');
+
+disable_data_checksums($node, wait => 1);
+
+$node->stop;
+done_testing();
diff --git a/src/test/modules/test_checksums/t/003_standby_restarts.pl b/src/test/modules/test_checksums/t/003_standby_restarts.pl
new file mode 100644
index 00000000000..f724d4ea74c
--- /dev/null
+++ b/src/test/modules/test_checksums/t/003_standby_restarts.pl
@@ -0,0 +1,114 @@
+
+# Copyright (c) 2024, PostgreSQL Global Development Group
+
+# Test suite for testing enabling data checksums in an online cluster with
+# streaming replication
+use strict;
+use warnings FATAL => 'all';
+use PostgreSQL::Test::Cluster;
+use PostgreSQL::Test::Utils;
+use Test::More;
+
+use FindBin;
+use lib $FindBin::RealBin;
+
+use DataChecksums::Utils;
+
+# Initialize primary node
+my $node_primary = PostgreSQL::Test::Cluster->new('primary');
+$node_primary->init(allows_streaming => 1, no_data_checksums => 1);
+$node_primary->start;
+
+my $slotname = 'physical_slot';
+$node_primary->safe_psql('postgres',
+	"SELECT pg_create_physical_replication_slot('$slotname')");
+
+# Take backup
+my $backup_name = 'my_backup';
+$node_primary->backup($backup_name);
+
+# Create streaming standby linking to primary
+my $node_standby_1 = PostgreSQL::Test::Cluster->new('standby_1');
+$node_standby_1->init_from_backup($node_primary, $backup_name,
+	has_streaming => 1);
+$node_standby_1->append_conf(
+	'postgresql.conf', qq[
+primary_slot_name = '$slotname'
+]);
+$node_standby_1->start;
+
+# Create some content on the primary to have un-checksummed data in the cluster
+$node_primary->safe_psql('postgres',
+	"CREATE TABLE t AS SELECT generate_series(1,10000) AS a;");
+
+# Wait for standbys to catch up
+$node_primary->wait_for_catchup($node_standby_1, 'replay',
+	$node_primary->lsn('insert'));
+
+# Check that checksums are turned off on all nodes
+test_checksum_state($node_primary, 'off');
+test_checksum_state($node_standby_1, 'off');
+
+# ---------------------------------------------------------------------------
+# Enable checksums for the cluster, and make sure that both the primary and
+# standby change state.
+#
+
+# Ensure that the primary switches to "inprogress-on"
+enable_data_checksums($node_primary, wait => 'inprogress-on');
+# Wait for checksum enable to be replayed
+$node_primary->wait_for_catchup($node_standby_1, 'replay');
+
+# Ensure that the standby has switched to "inprogress-on" or "on".  Normally it
+# would be "inprogress-on", but it is theoretically possible for the primary to
+# complete the checksum enabling *and* have the standby replay that record
+# before we reach the check below.
+my $result = $node_standby_1->poll_query_until(
+	'postgres',
+	"SELECT setting = 'off' FROM pg_catalog.pg_settings WHERE name = 'data_checksums';",
+	'f');
+is($result, 1, 'ensure standby has absorbed the inprogress-on barrier');
+$result = $node_standby_1->safe_psql('postgres',
+	"SELECT setting FROM pg_catalog.pg_settings WHERE name = 'data_checksums';"
+);
+
+is(($result eq 'inprogress-on' || $result eq 'on'),
+	1, 'ensure checksums are on, or in progress, on standby_1');
+
+# Insert some more data which should be checksummed on INSERT
+$node_primary->safe_psql('postgres',
+	"INSERT INTO t VALUES (generate_series(1, 10000));");
+
+# Wait for checksums enabled on the primary and standby
+wait_for_checksum_state($node_primary, 'on');
+wait_for_checksum_state($node_standby_1, 'on');
+
+$result =
+  $node_primary->safe_psql('postgres', "SELECT count(a) FROM t WHERE a > 1");
+is($result, '19998', 'ensure we can safely read all data with checksums');
+
+$result = $node_primary->poll_query_until(
+	'postgres',
+	"SELECT count(*) FROM pg_stat_activity WHERE backend_type LIKE 'datachecksumsworker%';",
+	'0');
+is($result, 1, 'await datachecksums worker/launcher termination');
+
+#
+# Disable checksums and ensure it's propagated to standby and that we can
+# still read all data
+#
+
+# Disable checksums and wait for the operation to be replayed
+disable_data_checksums($node_primary);
+$node_primary->wait_for_catchup($node_standby_1, 'replay');
+# Ensure that the primary abd standby has switched to off
+wait_for_checksum_state($node_primary, 'off');
+wait_for_checksum_state($node_standby_1, 'off');
+# Doublecheck reading data without errors
+$result =
+  $node_primary->safe_psql('postgres', "SELECT count(a) FROM t WHERE a > 1");
+is($result, "19998", 'ensure we can safely read all data without checksums');
+
+$node_standby_1->stop;
+$node_primary->stop;
+done_testing();
diff --git a/src/test/modules/test_checksums/t/004_offline.pl b/src/test/modules/test_checksums/t/004_offline.pl
new file mode 100644
index 00000000000..e9fbcf77eab
--- /dev/null
+++ b/src/test/modules/test_checksums/t/004_offline.pl
@@ -0,0 +1,82 @@
+
+# Copyright (c) 2024, PostgreSQL Global Development Group
+
+# Test suite for testing enabling data checksums offline from various states
+# of checksum processing
+use strict;
+use warnings FATAL => 'all';
+
+use PostgreSQL::Test::Cluster;
+use PostgreSQL::Test::Utils;
+use Test::More;
+
+use FindBin;
+use lib $FindBin::RealBin;
+
+use DataChecksums::Utils;
+
+# Initialize node with checksums disabled.
+my $node = PostgreSQL::Test::Cluster->new('main');
+$node->init(no_data_checksums => 1);
+$node->start;
+
+# Create some content to have un-checksummed data in the cluster
+$node->safe_psql('postgres',
+	"CREATE TABLE t AS SELECT generate_series(1,10000) AS a;");
+
+# Ensure that checksums are disabled
+test_checksum_state($node, 'off');
+
+# Enable checksums offline using pg_checksums
+$node->stop;
+$node->checksum_enable_offline;
+$node->start;
+
+# Ensure that checksums are enabled
+test_checksum_state($node, 'on');
+
+# Run a dummy query just to make sure we can read back some data
+my $result =
+  $node->safe_psql('postgres', "SELECT count(*) FROM t WHERE a > 1");
+is($result, '9999', 'ensure checksummed pages can be read back');
+
+# Disable checksums offline again using pg_checksums
+$node->stop;
+$node->checksum_disable_offline;
+$node->start;
+
+# Ensure that checksums are disabled
+test_checksum_state($node, 'off');
+
+# Create a barrier for checksumming to block on, in this case a pre-existing
+# temporary table which is kept open while processing is started. We can
+# accomplish this by setting up an interactive psql process which keeps the
+# temporary table created as we enable checksums in another psql process.
+
+my $bsession = $node->background_psql('postgres');
+$bsession->query_safe('CREATE TEMPORARY TABLE tt (a integer);');
+
+# In another session, make sure we can see the blocking temp table but start
+# processing anyways and check that we are blocked with a proper wait event.
+$result = $node->safe_psql('postgres',
+	"SELECT relpersistence FROM pg_catalog.pg_class WHERE relname = 'tt';");
+is($result, 't', 'ensure we can see the temporary table');
+
+enable_data_checksums($node, wait => 'inprogress-on');
+
+# Turn the cluster off and enable checksums offline, then start back up
+$bsession->quit;
+$node->stop;
+$node->checksum_enable_offline;
+$node->start;
+
+# Ensure that checksums are now enabled even though processing wasn't
+# restarted
+test_checksum_state($node, 'on');
+
+# Run a dummy query just to make sure we can read back some data
+$result = $node->safe_psql('postgres', "SELECT count(*) FROM t WHERE a > 1");
+is($result, '9999', 'ensure checksummed pages can be read back');
+
+$node->stop;
+done_testing();
diff --git a/src/test/modules/test_checksums/t/005_injection.pl b/src/test/modules/test_checksums/t/005_injection.pl
new file mode 100644
index 00000000000..ae801cd336f
--- /dev/null
+++ b/src/test/modules/test_checksums/t/005_injection.pl
@@ -0,0 +1,126 @@
+
+# Copyright (c) 2025, PostgreSQL Global Development Group
+
+# Test suite for testing enabling data checksums in an online cluster with
+# injection point tests injecting failures into the processing
+
+use strict;
+use warnings FATAL => 'all';
+
+use PostgreSQL::Test::Cluster;
+use PostgreSQL::Test::Utils;
+use Test::More;
+
+use FindBin;
+use lib $FindBin::RealBin;
+
+use DataChecksums::Utils;
+
+if ($ENV{enable_injection_points} ne 'yes')
+{
+	plan skip_all => 'Injection points not supported by this build';
+}
+
+# ---------------------------------------------------------------------------
+# Test cluster setup
+#
+
+# Initiate testcluster
+my $node = PostgreSQL::Test::Cluster->new('main');
+$node->init(no_data_checksums => 1);
+$node->start;
+
+# Set up test environment
+$node->safe_psql('postgres', 'CREATE EXTENSION test_checksums;');
+
+# ---------------------------------------------------------------------------
+# Inducing failures and crashes in processing
+
+# Force enabling checksums to fail by marking one of the databases as having
+# failed in processing.
+disable_data_checksums($node, wait => 1);
+$node->safe_psql('postgres', 'SELECT dcw_inject_fail_database(true);');
+enable_data_checksums($node, wait => 'off');
+$node->safe_psql('postgres', 'SELECT dcw_inject_fail_database(false);');
+
+# Force the server to crash after enabling data checksums but before issuing
+# the checkpoint.  Since the switch has been WAL logged the server should come
+# up with checksums enabled after replay.
+test_checksum_state($node, 'off');
+$node->safe_psql('postgres', 'SELECT dc_crash_before_checkpoint();');
+enable_data_checksums($node, fast => 'true');
+my $ret = wait_for_cluster_crash($node);
+ok($ret == 1, "Cluster crash detection timeout");
+ok(!$node->is_alive, "Cluster crashed due to abort() before checkpointing");
+$node->_update_pid(-1);
+$node->start;
+test_checksum_state($node, 'on');
+
+# Another test just like the previous, but for disabling data checksums (and
+# crashing just before checkpointing).  The previous injection points were all
+# detached from through the crash so they need to be reattached.
+$node->safe_psql('postgres', 'SELECT dc_crash_before_checkpoint();');
+disable_data_checksums($node);
+$ret = wait_for_cluster_crash($node);
+ok($ret == 1, "Cluster crash detection timeout");
+ok(!$node->is_alive, "Cluster crashed due to abort() before checkpointing");
+$node->_update_pid(-1);
+$node->start;
+test_checksum_state($node, 'off');
+
+# Now inject a crash before inserting the WAL record for data checksum state
+# change, when the server comes back up again the state should not have been
+# set to the new value since the process didn't succeed.
+$node->safe_psql('postgres', 'SELECT dc_crash_before_xlog();');
+enable_data_checksums($node);
+$ret = wait_for_cluster_crash($node);
+ok($ret == 1, "Cluster crash detection timeout");
+ok(!$node->is_alive, "Cluster crashed");
+$node->_update_pid(-1);
+$node->start;
+test_checksum_state($node, 'off');
+
+# This re-runs the same test again but with first disabling data checksums and
+# then enabling again, crashing right before inserting the WAL record.  When
+# it comes back up the checksums must not be enabled.
+$node->safe_psql('postgres', 'SELECT dc_crash_before_xlog();');
+enable_data_checksums($node);
+$ret = wait_for_cluster_crash($node);
+ok($ret == 1, "Cluster crash detection timeout");
+ok(!$node->is_alive, "Cluster crashed");
+$node->_update_pid(-1);
+$node->start;
+test_checksum_state($node, 'off');
+
+# ---------------------------------------------------------------------------
+# Timing and retry related tests
+#
+
+# Force the enable checksums processing to make multiple passes by removing
+# one database from the list in the first pass.  This will simulate a CREATE
+# DATABASE during processing.  Doing this via fault injection makes the test
+# not be subject to exact timing.
+$node->safe_psql('postgres', 'SELECT dcw_prune_dblist(true);');
+enable_data_checksums($node, wait => 'on');
+
+SKIP:
+{
+	skip 'Data checksum delay tests not enabled in PG_TEST_EXTRA', 4
+	  if (!$ENV{PG_TEST_EXTRA}
+		|| $ENV{PG_TEST_EXTRA} !~ /\bchecksum_extended\b/);
+
+	# Inject a delay in the barrier for enabling checksums
+	disable_data_checksums($node, wait => 1);
+	$node->safe_psql('postgres', 'SELECT dcw_inject_delay_barrier();');
+	enable_data_checksums($node, wait => 'on');
+
+	# Fake the existence of a temporary table at the start of processing, which
+	# will force the processing to wait and retry in order to wait for it to
+	# disappear.
+	disable_data_checksums($node, wait => 1);
+	$node->safe_psql('postgres', 'SELECT dcw_fake_temptable(true);');
+	enable_data_checksums($node, wait => 'on');
+}
+
+$node->stop;
+done_testing();
diff --git a/src/test/modules/test_checksums/t/006_pgbench_single.pl b/src/test/modules/test_checksums/t/006_pgbench_single.pl
new file mode 100644
index 00000000000..96f3b2cd8a6
--- /dev/null
+++ b/src/test/modules/test_checksums/t/006_pgbench_single.pl
@@ -0,0 +1,268 @@
+
+# Copyright (c) 2025, PostgreSQL Global Development Group
+
+# Test suite for testing enabling data checksums in an online cluster with
+# concurrent activity via pgbench runs
+
+use strict;
+use warnings FATAL => 'all';
+
+use PostgreSQL::Test::Cluster;
+use PostgreSQL::Test::Utils;
+use Test::More;
+
+use FindBin;
+use lib $FindBin::RealBin;
+
+use DataChecksums::Utils;
+
+if (!$ENV{PG_TEST_EXTRA} || $ENV{PG_TEST_EXTRA} !~ /\bchecksum_extended\b/)
+{
+	plan skip_all => 'Extended tests not enabled';
+}
+
+if ($ENV{enable_injection_points} ne 'yes')
+{
+	plan skip_all => 'Injection points not supported by this build';
+}
+
+my $node;
+my $node_loglocation = 0;
+
+# The number of full test iterations which will be performed. The exact number
+# of tests performed and the wall time taken is non-deterministic as the test
+# performs a lot of randomized actions, but 10 iterations will be a long test
+# run regardless.
+my $TEST_ITERATIONS = 10;
+
+# Variables which record the current state of the cluster
+my $data_checksum_state = 'off';
+my $pgbench = undef;
+
+# determines whether enable_data_checksums/disable_data_checksums forces an
+# immediate checkpoint
+my @flip_modes = ('true', 'false');
+
+# Start a pgbench run in the background against the server specified via the
+# port passed as parameter.
+sub background_rw_pgbench
+{
+	my $port = shift;
+
+	# If a previous pgbench is still running, start by shutting it down.
+	if ($pgbench)
+	{
+		$pgbench->finish;
+	}
+
+	# Randomize the number of pgbench clients a bit (range 1-16)
+	my $clients = 1 + int(rand(15));
+
+	my @cmd = ('pgbench', '-p', $port, '-T', '600', '-c', $clients);
+
+	# Randomize whether we spawn connections or not
+	push(@cmd, '-C') if (cointoss);
+	# Finally add the database name to use
+	push(@cmd, 'postgres');
+
+	$pgbench = IPC::Run::start(
+		\@cmd,
+		'<' => '/dev/null',
+		'>' => '/dev/null',
+		'2>' => '/dev/null',
+		IPC::Run::timer($PostgreSQL::Test::Utils::timeout_default));
+}
+
+# Invert the state of data checksums in the cluster, if data checksums are on
+# then disable them and vice versa. Also performs proper validation of the
+# before and after state.
+sub flip_data_checksums
+{
+	# First, make sure the cluster is in the state we expect it to be
+	test_checksum_state($node, $data_checksum_state);
+
+	if ($data_checksum_state eq 'off')
+	{
+		# Coin-toss to see if we are injecting a retry due to a temptable
+		$node->safe_psql('postgres', 'SELECT dcw_fake_temptable();')
+		  if cointoss();
+
+		# log LSN right before we start changing checksums
+		my $result =
+		  $node->safe_psql('postgres', "SELECT pg_current_wal_lsn()");
+		note("LSN before enabling: " . $result . "\n");
+
+		my $mode = $flip_modes[ int(rand(@flip_modes)) ];
+
+		# Ensure that the primary switches to "inprogress-on"
+		enable_data_checksums(
+			$node,
+			wait => 'inprogress-on',
+			'fast' => $mode);
+
+		random_sleep();
+
+		# Wait for checksums enabled on the primary
+		wait_for_checksum_state($node, 'on');
+
+		# log LSN right after the primary flips checksums to "on"
+		$result = $node->safe_psql('postgres', "SELECT pg_current_wal_lsn()");
+		note("LSN after enabling: " . $result . "\n");
+
+		random_sleep();
+
+		$node->safe_psql('postgres', 'SELECT dcw_fake_temptable(false);');
+		$data_checksum_state = 'on';
+	}
+	elsif ($data_checksum_state eq 'on')
+	{
+		random_sleep();
+
+		# log LSN right before we start changing checksums
+		my $result =
+		  $node->safe_psql('postgres', "SELECT pg_current_wal_lsn()");
+		note("LSN before disabling: " . $result . "\n");
+
+		my $mode = $flip_modes[ int(rand(@flip_modes)) ];
+
+		disable_data_checksums($node, 'fast' => $mode);
+
+		# Wait for checksums disabled on the primary
+		wait_for_checksum_state($node, 'off');
+
+		# log LSN right after the primary flips checksums to "off"
+		$result = $node->safe_psql('postgres', "SELECT pg_current_wal_lsn()");
+		note("LSN after disabling: " . $result . "\n");
+
+		random_sleep();
+
+		$data_checksum_state = 'off';
+	}
+	else
+	{
+		# This should only happen due to programmer error when hacking on the
+		# test code, but since that might pass subtly by let's ensure it gets
+		# caught with a test error if so.
+		bail('data_checksum_state variable has invalid state:'
+			  . $data_checksum_state);
+	}
+}
+
+# Create and start a cluster with one node
+$node = PostgreSQL::Test::Cluster->new('main');
+$node->init(allows_streaming => 1, no_data_checksums => 1);
+# max_connections need to be bumped in order to accommodate for pgbench clients
+# and log_statement is dialled down since it otherwise will generate enormous
+# amounts of logging. Page verification failures are still logged.
+$node->append_conf(
+	'postgresql.conf',
+	qq[
+max_connections = 100
+log_statement = none
+]);
+$node->start;
+$node->safe_psql('postgres', 'CREATE EXTENSION test_checksums;');
+# Create some content to have un-checksummed data in the cluster
+$node->safe_psql('postgres',
+	"CREATE TABLE t AS SELECT generate_series(1, 100000) AS a;");
+# Initialize pgbench
+$node->command_ok([ 'pgbench', '-i', '-s', '100', '-q', 'postgres' ]);
+# Start the test suite with pgbench running.
+background_rw_pgbench($node->port);
+
+# Main test suite. This loop will start a pgbench run on the cluster and while
+# that's running flip the state of data checksums concurrently. It will then
+# randomly restart thec cluster (in fast or immediate) mode and then check for
+# the desired state.  The idea behind doing things randomly is to stress out
+# any timing related issues by subjecting the cluster for varied workloads.
+# A TODO is to generate a trace such that any test failure can be traced to
+# its order of operations for debugging.
+for (my $i = 0; $i < $TEST_ITERATIONS; $i++)
+{
+	note("iteration ", ($i + 1), " of ", $TEST_ITERATIONS);
+
+	if (!$node->is_alive)
+	{
+		random_sleep();
+
+		# Start, to do recovery, and stop
+		$node->start;
+		$node->stop('fast');
+
+		# Since the log isn't being written to now, parse the log and check
+		# for instances of checksum verification failures.
+		my $log = PostgreSQL::Test::Utils::slurp_file($node->logfile,
+			$node_loglocation);
+		unlike(
+			$log,
+			qr/page verification failed/,
+			"no checksum validation errors in primary log (during WAL recovery)"
+		);
+		$node_loglocation = -s $node->logfile;
+
+		# Randomize the WAL size, to trigger checkpoints less/more often
+		my $sb = 64 + int(rand(1024));
+		$node->append_conf('postgresql.conf', qq[max_wal_size = $sb]);
+
+		$node->start;
+
+		# Start a pgbench in the background against the primary
+		background_rw_pgbench($node->port);
+	}
+
+	$node->safe_psql('postgres', "UPDATE t SET a = a + 1;");
+
+	flip_data_checksums();
+	random_sleep();
+	my $result =
+	  $node->safe_psql('postgres', "SELECT count(*) FROM t WHERE a > 1");
+	is($result, '100000', 'ensure data pages can be read back on primary');
+
+	random_sleep();
+
+	# Potentially powercycle the node
+	if (cointoss())
+	{
+		$node->stop(stopmode());
+
+		PostgreSQL::Test::Utils::system_log("pg_controldata",
+			$node->data_dir);
+
+		my $log = PostgreSQL::Test::Utils::slurp_file($node->logfile,
+			$node_loglocation);
+		unlike(
+			$log,
+			qr/page verification failed/,
+			"no checksum validation errors in primary log (outside WAL recovery)"
+		);
+		$node_loglocation = -s $node->logfile;
+	}
+
+	random_sleep();
+}
+
+# Make sure the node is running
+if (!$node->is_alive)
+{
+	$node->start;
+}
+
+# Testrun is over, ensure that data reads back as expected and perform a final
+# verification of the data checksum state.
+my $result =
+  $node->safe_psql('postgres', "SELECT count(*) FROM t WHERE a > 1");
+is($result, '100000', 'ensure data pages can be read back on primary');
+test_checksum_state($node, $data_checksum_state);
+
+# Perform one final pass over the logs and hunt for unexpected errors
+my $log =
+  PostgreSQL::Test::Utils::slurp_file($node->logfile, $node_loglocation);
+unlike(
+	$log,
+	qr/page verification failed/,
+	"no checksum validation errors in primary log");
+$node_loglocation = -s $node->logfile;
+
+$node->teardown_node;
+
+done_testing();
